#include <ntddk.h>
#include "z.h"



#define seconds_per_day				86400



// PROTOS
PBYTE Time_Date_Stamp(DWORD tds);
PBYTE Convert_Number_To_ASCII(DWORD Number_To_Display);



// DECLARE GLOBAL VARIABLES
	BYTE time_date[25], bytes_to_write[15];



// EXTERNAL C FUNCTION
PBYTE Time_Date_Stamp(DWORD tds){
	int MONTH_ARRAY[12] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	int LEAP_YEAR_ARRAY[20] = {1972, 1976, 1980, 1984, 1988, 1992, 1996, 2000, 2004, 2008, 2012, 2016, 2020, 2024, 2028, 2032, 2036, 2040, 2044, 2048};
	int month = 7, day = 4, year = 1776, hour = 30, minute = 40, second = 50, i = 0, j = 0;
	int seconds_left = 0;


	day = tds / seconds_per_day;							// Year
	year = day / 365;
	year = year + 1970;

	j = 0;													// count leap years
	for(i = 0; i < 20; i++){if ((year > LEAP_YEAR_ARRAY[i]) && (year != LEAP_YEAR_ARRAY[i])) j = j + 1;}

	seconds_left = tds - (((year - 1970) * seconds_per_day * 365) + j * seconds_per_day);
	day = seconds_left / seconds_per_day;
	seconds_left = seconds_left - (86400 * day);

	month = 1;												// Month
	for(j = 0; j < 12; j++){
	if((MONTH_ARRAY[j] == 28) && (year == 1972 || year == 1976 || year == 1980 || year == 1984 || year == 1988 || year == 1992 || year == 1996 || year == 2000 || year == 2004 || year == 2008 || year == 2012 || year == 2016 || year == 2020 || year == 2024 || year == 2028 || year == 2032 || year == 2036 || year == 2040)) i = 1;
	else i = 0;
	day = day - (MONTH_ARRAY[j] + i);						// Day
	if( day > 0 ) 
		{
		month = month + 1; 
		}
	else
		{
		day = day + (MONTH_ARRAY[j] + i);
		goto skippy;
		}
	}
skippy:;
	day = day + 1;

	hour = seconds_left / 3600;								// Hour
	seconds_left = seconds_left - (hour * 3600);		

	minute = seconds_left / 60;								// Minute
	second = seconds_left - (minute * 60);					// Second



// FILL MM/DD/YY HH:MM:SS BUFFER
// MONTH
	Convert_Number_To_ASCII(month);
	time_date[0] = bytes_to_write[0];
	time_date[1] = bytes_to_write[1];
	time_date[2] = '/';
// DAY
	Convert_Number_To_ASCII(day);
	time_date[3] = bytes_to_write[0];
	time_date[4] = bytes_to_write[1];
	time_date[5] = '/';
// YEAR
	Convert_Number_To_ASCII(year);
	time_date[6] = bytes_to_write[0];
	time_date[7] = bytes_to_write[1];
	time_date[8] = bytes_to_write[2];
	time_date[9] = bytes_to_write[3];
	time_date[10] = ' ';
// HOUR
	Convert_Number_To_ASCII(hour);
	time_date[11] = bytes_to_write[0];
	time_date[12] = bytes_to_write[1];
	time_date[13] = ':';
// MINUTE
	Convert_Number_To_ASCII(minute);
	time_date[14] = bytes_to_write[0];
	time_date[15] = bytes_to_write[1];
	time_date[16] = ':';
// SECOND
	Convert_Number_To_ASCII(second);
	time_date[17] = bytes_to_write[0];
	time_date[18] = bytes_to_write[1];
	time_date[19] = 0;
	return (PBYTE)&time_date;}



// FUNCTION TO CONVERT NUMBER TO ASCII
PBYTE Convert_Number_To_ASCII(DWORD Number_To_Display){
		DWORD remain_deer, work_num, read_counter, write_counter;
		BYTE bytes_to_read[15];
		write_counter = 0;
		do
		{	
			bytes_to_write[write_counter] = 32;
			write_counter = write_counter + 1;
		} 
		while ( write_counter < 15);
		read_counter = 0;
		do
		{
			remain_deer = Number_To_Display % 10;
			work_num = Number_To_Display / 10;	 
			Number_To_Display = work_num;				 
			bytes_to_read[read_counter] = (BYTE)(remain_deer + 48);
			read_counter = read_counter + 1;	
		} 
		while (Number_To_Display != 0);
		write_counter = 0;
		do
		{
			bytes_to_write[write_counter] = bytes_to_read[read_counter - 1];
			read_counter = read_counter - 1;
			write_counter = write_counter + 1;
		} 
		while (read_counter > 0);
		if (bytes_to_write[1] == 32)
			{
			bytes_to_write[1] = bytes_to_write[0];
			bytes_to_write[0] = '0';
			}
		return (PBYTE)&bytes_to_write;}

  