.586
.model flat, stdcall
option casemap:none
;........................................................................
; MACROS
;........................................................................
CTL_CODE MACRO DeviceType,Function,Method,Access
EXITM %(((DeviceType) SHL 16) OR ((Access) SHL 14) OR ((Function) SHL 2) OR (Method))
ENDM
;........................................................................
; INCLUDES
;........................................................................
	include windows.inc
	include advapi32.inc		; Service Control Manager Application Program Interface Functions
	include kernel32.inc
	include masm32.inc		; StdOut	
	include user32.inc
	includelib advapi32.lib
	includelib kernel32.lib
	includelib masm32.lib
	includelib user32.lib
;........................................................................
; EXTRNS
;........................................................................
	wsprintfA PROTO C :DWORD,:VARARG
	wsprintf equ <wsprintfA>
;........................................................................
; DATA
;........................................................................
.data
; Display_Number procedure variables
	OUT_NUMBER				DD 0
	num_char_written			DD 0
	bytes_to_write			DB 0
; Input_Number procedure  variables
	IN_NUMBER				DD 0
	num_char_read			DD 0
	bytes_to_read			DB 0
; initialize sys procedure variables
	file_path				DB 512 DUP(0)
	size_of_file_path			DD 0
; control codes
	IOCTL_SPEAKER_ON			EQU CTL_CODE(8010h, 820h, 0, 0)
	IOCTL_SPEAKER_OFF			EQU CTL_CODE(8010h, 830h, 0, 0)
	IOCTL_READ_HARD_DISK_SECTOR	EQU CTL_CODE(8010h, 840h, 0, 0)
	IOCTL_READ_MEMORY			EQU CTL_CODE(8010h, 850h, 0, 0)
	IOCTL_FUNCTION_ADDRESS		EQU CTL_CODE(8010h, 860h, 0, 0)
	IOCTL_UNKNOWN1			EQU CTL_CODE(8010h, 870h, 0, 0)
	IOCTL_UNKNOWN2			EQU CTL_CODE(8010h, 880h, 0, 0)
	IOCTL_UNKNOWN3			EQU CTL_CODE(8010h, 890h, 0, 0)
; general variables
_sDataStruct				STRUC
	Status				DD ?
	c1					DB ?
	c2					DB ?
	c3					DB ?
	c4					DB ?
	b					DB 512 DUP(?)
_sDataStruct				ENDS
	dStruct				_sDataStruct <>
	ServiceStatus 			SERVICE_STATUS <>
	hDriver				DD 0
	dwBytesReturned			DD 0
	service_handle 			DD 0
	manager_handle			DD 0
	bool_test				DD 0
	counter				DD 0
	std_handle_r			DD 0
	std_handle_w			DD 0
	control_value			DD 0
	RETURN_VALUE			DD 0
	sys_name				DB "roak", 0
	create_roak				DB "\\.\roak", 0
; messages
	msg_buf				DB 200 dup(0)
	msg_sch				DB 10, 13, '     Sector = %2d, Cylinder = %5d, Drive = 160,', 10, 13, '     Drive + Head = %5d will be read.', 10, 13, 0
	msg_crlf				DB ".", 10, 13
	msg_enter_sector			DB 10, 13, '     Enter a sector number from 1 to 63: '
	msg_enter_cylinder		DB 10, 13, '     Enter realistic word value for # of cylinder: '
	msg_enter_head			DB 10, 13, '     Enter a head number from 0 to 15: '
	msg_err				DB 10, 13, "     Error = "
	msg_call_result			DB 10, 13, "     The result from the call is DeviceIoControl = "
	msg_call_status			DB ', while Status = '
	msg_main				DB 10, 13, '     This program uses roak.sys to turn your computer speaker', 10, 13
						DB         '     on and off.  Enter the number 0 for off, or 1 for on.', 10, 13
						DB         "     Enter 2 to read a master disk sector and write the sector,", 10, 13
						DB         "     data to the file c:\roak.txt.  Enter 3 to get your mainboard", 10, 13
						DB         "     computer serial number and write its data page to the file", 10, 13
						DB         "     c:\roak.txt.  Enter 4 to call ntdll.lib function ZwGetTickCount", 10, 13
						DB         "     for 3 second delay.  Or, enter a number greater than 4 to exit: ", 0
	msg_content				DB ".", 10, 13, 10, 13, "     The contents of the 512 byte return buffer are: ", 10, 13, 10, 13
	msg_cw				DB 10, 13, 10, 13, "     Freehafer's Windows 2000 Loader", 10, 13, "     With Driver Program Is Terminated!", 10, 13, 10, 13, "     (c)2002 INNIEA PUBLISHING COMPANY!  R", 153, 142, "K NOG!"
	msg_hit				DB 10, 13, 10, 13, '     HIT ENTER KEY TO SEE BIBLIOGRAPHY . . . '
	msg_biblio_1			DB 10, 13, 10, 13, '               BIBLIOGRAPHY', 10, 13, 10, 13, '     1. http://assembly.ifrance.com/assembly/WinNT.txt', 10, 13, '     Assembly Code, Pulsar Fevrier.', 10, 13, 10, 13
	msg_biblio_2			DB '     2. http://board.win32asmcommunity.net/showthread.php?s=&threadid=1961', 10, 13, '     Control Code, Bit7, BitRAKE.', 10, 13, 10, 13
	msg_biblio_3			DB '     3. http://www.internals.com', 10, 13, '     Flow Chart, Yariv Kaplan.', 10, 13, 10, 13
	msg_biblio_4			DB '     4. http://board.win32asmcommunity.net/showthread.php?s=&threadid=2613', 10, 13, '     Linking, jmp $FCE2.', 10, 13, 10, 13
	msg_biblio_5			DB '     5. http://www.anticracking.sk/EliCZ/', 10, 13, '     Passing Data, EliCZ.', 10, 13, 10, 13
	msg_biblio_6			DB '     6. http://board.win32asmcommunity.net/showthread.php?s=&threadid=3493', 10, 13, '     Structure And Use Of DD, madprgmr.', 10, 13, 10, 13
	msg_biblio_7			DB '     7. http://www.sysinternals.com/files/physmem.zip', 10, 13, '     Mapping Memory With ZwOpenSection, Russinovich.', 10, 13, 10, 13
	msg_biblio_8			DB '     8. http://www.newriders.com/native', 10, 13, '     Native Application Program Interface Reference, Nebbett.', 10, 13, 10, 13
	msg_biblio_9			DB '     9. http://www.google.com', 10, 13, '     Create & Restore Handler, Anatoly Vorobey.', 10, 13, 10, 13
	msg_biblio_A			DB '     A. http://board.win32asmcommunity.net/showthread.php?s=&threadid=6086', 10, 13, '     Pointer Arithmetic, Dr. Manhattan.', 10, 13, 10, 13
	msg_biblio_B			DB '     B. http://www.orgon.com/w2k_internals/', 10, 13, '     Calling Ntdll.dll Functions From Ring Zero, Schreiber.', 10, 13, 10, 13, '     Hit enter key to exit . . . '
;........................................................................
; CODE
;........................................................................
.code
start:
	call Get_Console_Handles						; GET HANDLES
	invoke StdOut, ADDR msg_main
	call Input_Number								; CHOSE A DRIVER FUNCTION 0, 1, 2, etc.
	mov EAX, IN_NUMBER
	mov control_value, EAX
	.if (control_value > 4)
	jmp ender
	.endif
	.if (control_value == 2)
	call Fill_Structure							; FILL STRUCT IF DATA TO BE TRANSFERED TO AND FROM SYS FOR SECTOR READ
	.endif
do_it_again:
	call Initialize_Roak_Sys						; INITIALIZE DRIVER
	.if(EAX == 0)								; ERROR!
	invoke GetLastError
	mov OUT_NUMBER, EAX
	inc counter
	invoke WriteConsole, std_handle_w, ADDR msg_err, sizeof msg_err, ADDR num_char_written, 0
	call Output_Number							; DISPLAY ERROR CODE
	invoke WriteConsole, std_handle_w, ADDR msg_crlf, sizeof msg_crlf, ADDR num_char_written, 0
	.if(counter > 100)
	jmp to_exit
	.endif
	jmp do_it_again
	.endif
	call Choose_Roak_Function						; CHOOSE DRIVER FUNCTION
	mov RETURN_VALUE, EAX							; GET RETURN FROM FUNCTION CALL 
	call Display_Struct_Output						; DISPLAY OUTPUT FROM STRUCTURE
to_exit:
	call Shut_Down_Roak							; SHUT DOWN DRIVER
ender:
	call Finish_Up
;........................................................................
; PROCEDURES>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;........................................................................
; PROCEDURE TO GET CONSOLE HANDLES
;........................................................................
Get_Console_Handles proc
	invoke GetStdHandle, -11						; get handles to console
	mov std_handle_w, EAX
	invoke GetStdHandle, -10
	mov std_handle_r, EAX
	ret
Get_Console_Handles endp
;........................................................................
; PROCEDURE TO INITIALIZE DRIVER
;........................................................................
Initialize_Roak_Sys proc
	invoke GetModuleHandle, 0
	invoke GetModuleFileName, EAX, ADDR file_path, 512
	mov size_of_file_path, EAX
	mov EBX, size_of_file_path
slash_again:
	.if (file_path[EBX] == '\')
	jmp break_slash
	.endif
	dec EBX
	jmp slash_again
break_slash:
	mov dword ptr file_path[EBX+1], 'KAOR'
	mov dword ptr file_path[EBX+5], 'SYS.'
	mov dword ptr file_path[EBX+9], 0
	invoke OpenSCManager, 0, 0, 983103					; 983103 = SC_MANAGER_ALL_ACCESS
	mov manager_handle, EAX
	invoke OpenService, manager_handle, ADDR sys_name, 983551	; 983551 = SERVICE_ALL_ACCESS
	mov service_handle, EAX
	invoke ControlService, service_handle, 1,  ADDR ServiceStatus; 1 = SERVICE_CONTROL_STOP
	invoke CloseServiceHandle, service_handle				; CLOSE HANDLE
	invoke OpenService, manager_handle, ADDR sys_name, 983551	; 983551 = SERVICE_ALL_ACCESS
	mov service_handle, EAX
	invoke DeleteService, service_handle				; SEND REMOVE COMMAND TO SERVICE MANAGER 
	invoke CloseServiceHandle, service_handle				; CLOSE HANDLE
	invoke CreateService, manager_handle, ADDR sys_name, ADDR sys_name, 983551, 1, 3, 1, ADDR file_path, 0, 0, 0, 0, 0	; 983551 = SERVICE_ALL_ACCESS, 1 = SERVICE_KERNEL_DRIVER, 3 = SERVICE_DEMAND_START, 1 = SERVICE_ERROR_NORMAL
	mov service_handle, EAX
	invoke OpenService, manager_handle, ADDR sys_name, 983551	; 983551 = SERVICE_ALL_ACCESS
	mov service_handle, EAX
	invoke StartService, service_handle, 0, 0				; SEND START DRIVER COMMAND
	invoke CloseServiceHandle, service_handle				; CLOSE HANDLE
	invoke CreateFile, ADDR create_roak, GENERIC_READ or GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
	mov hDriver, EAX  
	.if(hDriver != INVALID_HANDLE_VALUE)
	mov bool_test, 1
	.else
	invoke CloseHandle, hDriver
	mov bool_test, 0
	.endif
	invoke CloseServiceHandle, manager_handle	
	mov EAX, bool_test
	ret
Initialize_Roak_Sys endp
;........................................................................
; PROCEDURE TO SHUT DOWN DRIVER
;........................................................................
Shut_Down_Roak proc
	invoke OpenSCManager, 0, 0, 983103					; 983103 = SC_MANAGER_ALL_ACCESS
	mov manager_handle, EAX							; GET SERVICE CONTROL HANDLE
	invoke OpenService, manager_handle, ADDR sys_name, 983551	; 983551 = SERVICE_ALL_ACCESS
	mov service_handle, EAX
	invoke ControlService, service_handle, 1, ADDR ServiceStatus; 1 = SERVICE_CONTROL_STOP
	invoke CloseServiceHandle, service_handle	; CLOSE HANDLE
	invoke OpenService, manager_handle, ADDR sys_name, 983551	; 983551 = SERVICE_ALL_ACCESS
	mov service_handle, EAX 
	invoke DeleteService, service_handle				; SEND REMOVE COMMAND
	invoke CloseServiceHandle, service_handle				; CLOSE HANDLE	
	mov EAX, 1
	ret
Shut_Down_Roak endp 
;........................................................................
; PROCEDURE TO CHOOSE FUNCTION IN DRIVER
;........................................................................
Choose_Roak_Function proc
	.IF control_value == 0
	invoke DeviceIoControl, hDriver, IOCTL_SPEAKER_OFF, ADDR dStruct, 520, ADDR dStruct, 520, ADDR dwBytesReturned, 0
	.ENDIF
	.IF control_value == 1
	invoke DeviceIoControl, hDriver, IOCTL_SPEAKER_ON, ADDR dStruct, 520, ADDR dStruct, 520, ADDR dwBytesReturned, 0
	.ENDIF
	.IF control_value == 2
	invoke DeviceIoControl, hDriver, IOCTL_READ_HARD_DISK_SECTOR, ADDR dStruct, 520, ADDR dStruct, 520, ADDR dwBytesReturned, 0
	.ENDIF
	.IF control_value == 3
	invoke DeviceIoControl, hDriver, IOCTL_READ_MEMORY, ADDR dStruct, 520, ADDR dStruct, 520, ADDR dwBytesReturned, 0
	.ENDIF
	.IF control_value == 4
	invoke DeviceIoControl, hDriver, IOCTL_FUNCTION_ADDRESS, ADDR dStruct, 520, ADDR dStruct, 520, ADDR dwBytesReturned, 0
	.ENDIF
	ret										; IF deviceIoControl RETURN IN EAX != 0 WE HAVE SUCCESS
Choose_Roak_Function endp
;........................................................................
; PROCEDURE TO DISPLAY NUMBER	
;........................................................................
Output_Number proc
	LOCAL COUNTER:DWORD
	push EAX
	push EBX
	push ECX
	push EDX
	mov EAX, OUT_NUMBER							; number to be displayed
	mov EBX, 10
	mov COUNTER, 0								; recalibrate counter
display_number_loop_next_divide:
	mov EDX, 0
	div EBX									; get next digit in EDX
	push EDX									; store digit 
	inc COUNTER
	cmp EAX, 0
	jne display_number_loop_next_divide
display_number_out_loop:
	pop EDX									; retrieve digit
	add DL, 48									; make a character
	mov bytes_to_write[0], DL						; put character into address
	invoke WriteConsole, std_handle_w, ADDR bytes_to_write, 1, ADDR num_char_written, 0
	dec COUNTER
	.IF (COUNTER > 0)
	jmp display_number_out_loop
	.ENDIF
	pop EDX
	pop ECX
	pop EBX
	pop EAX
	ret
Output_Number endp
;........................................................................
; PROCEDURE TO INPUT NUMBER
;........................................................................
Input_Number proc
	push EAX
	push EBX
	push ECX
	push EDX
	mov IN_NUMBER, 0
read_loop:
	mov EBX, 0
	invoke ReadConsole, std_handle_r, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	mov AL, bytes_to_read
	cmp AL, 0            							; special character? are not 0 to 9
	jne not_special        							; if not - process character
	jmp short exit_read          						; finished
not_special:
	cmp al,'0'          							; compare character read to "0" (number?)
	jb exit_read								; if not, don't process
	cmp AL, '9'          							; compare character read to "9" (number?)
	ja exit_read								; if not, don't process 
	sub AL, '0'          							; convert character to number
	mov BL, AL           							; copy character read into BX
	mov EAX, IN_NUMBER							; hex number into AX
	mov ECX, 10
	mul ECX             							; one decimal position to the left
	mov IN_NUMBER, EAX							; store result back into memory
	add IN_NUMBER, EBX							; add current hex digit
	jmp short read_loop     	     					; read next character
exit_read:
	pop EDX
	pop ECX
	pop EBX
	pop EAX
	ret
Input_Number endp
;........................................................................
; PROCEDURE TO FILL STRUCTURE FOR PASSING TO DRIVER
;........................................................................
Fill_Structure proc
	invoke ReadConsole, std_handle_r, ADDR bytes_to_read, sizeof bytes_to_read, ADDR num_char_read, 0
	invoke WriteConsole, std_handle_w, ADDR msg_enter_sector, sizeof msg_enter_sector, ADDR num_char_written, 0
	call Input_Number
	mov EAX, IN_NUMBER
	.IF EAX < 1 || EAX > 63							; ERROR CHECKING
	mov EAX, 1									; "
	.ENDIF									; "
	mov dStruct.c1, AL							; sector
	invoke ReadConsole, std_handle_r, ADDR bytes_to_read, 2, ADDR num_char_read, 0
	invoke WriteConsole, std_handle_w, ADDR msg_enter_cylinder, sizeof msg_enter_cylinder, ADDR num_char_written, 0
	call Input_Number
	mov EAX, IN_NUMBER
	.IF EAX < 0 || EAX > 65535						; ERROR CHECKING
	mov EAX, 0									; "
	.ENDIF									; "
	mov dStruct.c2, AH							; cylinder high
	mov dStruct.c3, AL							; cylinder low 
	invoke ReadConsole, std_handle_r, ADDR bytes_to_read, sizeof bytes_to_read, ADDR num_char_read, 0
	invoke WriteConsole, std_handle_w, ADDR msg_enter_head, sizeof msg_enter_head, ADDR num_char_written, 0
	call Input_Number
	mov EAX, IN_NUMBER
	.IF EAX < 0 || EAX > 15							; ERROR CHECKING
	mov EAX, 0									; "
	.ENDIF									; "
	; BIT	10100000b = 0A0h = 160 = MASTER HEAD 0
	; OR	00010000b = 0B0h = 176 = SLAVE HEAD 0
	; OR  00000000b to 00001111b or 0 to 15 heads
	or EAX, 0A0h
	mov dStruct.c4, AL							; head
	mov EAX, 0
	mov AL, dStruct.c1
	mov EBX, 0
	mov BH, dStruct.c2
	mov BL, dStruct.c3
	mov ECX, 0
	mov CL, dStruct.c4
	invoke wsprintf, ADDR msg_buf, ADDR msg_sch, EAX, EBX, ECX
	invoke WriteConsole, std_handle_w, ADDR msg_buf, sizeof msg_sch, ADDR num_char_written, 0
	ret
Fill_Structure endp
;........................................................................
; PROCEDURE TO DISPLAY OUTPUT FROM STRUCTURE
;........................................................................
Display_Struct_Output proc
	mov EAX, RETURN_VALUE
	mov OUT_NUMBER, EAX
	invoke WriteConsole, std_handle_w, ADDR msg_call_result, sizeof msg_call_result, ADDR num_char_written, 0
	call Output_Number
	invoke WriteConsole, std_handle_w, ADDR msg_call_status, sizeof msg_call_status, ADDR num_char_written, 0
	mov EAX, dStruct.Status;						; GET RETURN FROM FUNCTION CALL 
	mov OUT_NUMBER, EAX
	call Output_Number
	invoke WriteConsole, std_handle_w, ADDR msg_content, sizeof msg_content, ADDR num_char_written, 0
	invoke WriteConsole, std_handle_w, ADDR dStruct.b, 512, ADDR num_char_written, 0
	ret
Display_Struct_Output endp
;........................................................................
; PROCEDURE TO FINISH PROGRAM
;........................................................................
Finish_Up proc
	invoke WriteConsole, std_handle_w, ADDR msg_hit, sizeof msg_hit, ADDR num_char_written, 0
	invoke ReadConsole, std_handle_r, ADDR bytes_to_read, sizeof bytes_to_read, ADDR num_char_read, 0
	invoke ReadConsole, std_handle_r, ADDR bytes_to_read, sizeof bytes_to_read, ADDR num_char_read, 0
	invoke WriteConsole, std_handle_w, ADDR msg_cw, sizeof msg_cw, ADDR num_char_written, 0
	invoke WriteConsole, std_handle_w, ADDR msg_biblio_1, sizeof msg_biblio_1, ADDR num_char_written, 0
	invoke WriteConsole, std_handle_w, ADDR msg_biblio_2, sizeof msg_biblio_2, ADDR num_char_written, 0
	invoke WriteConsole, std_handle_w, ADDR msg_biblio_3, sizeof msg_biblio_3, ADDR num_char_written, 0
	invoke WriteConsole, std_handle_w, ADDR msg_biblio_4, sizeof msg_biblio_4, ADDR num_char_written, 0
	invoke WriteConsole, std_handle_w, ADDR msg_biblio_5, sizeof msg_biblio_5, ADDR num_char_written, 0
	invoke WriteConsole, std_handle_w, ADDR msg_biblio_6, sizeof msg_biblio_6, ADDR num_char_written, 0
	invoke WriteConsole, std_handle_w, ADDR msg_biblio_7, sizeof msg_biblio_7, ADDR num_char_written, 0
	invoke WriteConsole, std_handle_w, ADDR msg_biblio_8, sizeof msg_biblio_8, ADDR num_char_written, 0
	invoke WriteConsole, std_handle_w, ADDR msg_biblio_9, sizeof msg_biblio_9, ADDR num_char_written, 0
	invoke WriteConsole, std_handle_w, ADDR msg_biblio_A, sizeof msg_biblio_A, ADDR num_char_written, 0
	invoke WriteConsole, std_handle_w, ADDR msg_biblio_B, sizeof msg_biblio_B, ADDR num_char_written, 0
	invoke ReadConsole, std_handle_r, ADDR bytes_to_read, sizeof bytes_to_read, ADDR num_char_read, 0
	invoke ReadConsole, std_handle_r, ADDR bytes_to_read, sizeof bytes_to_read, ADDR num_char_read, 0
	invoke ExitProcess, 0
Finish_Up endp
;........................................................................
end start
