


// DEFINES
#define	DWORD						unsigned long
#define	WORD						unsigned short
#define	BYTE						unsigned char
#define max(a,b)					(((a) > (b)) ? (a) : (b))
#define SystemModuleInformation		11
#define PPVOID						PVOID*
#define PDWORD						DWORD*
#define PWORD						WORD*
#define PBYTE						BYTE*
#define IMAGE_DIRECTORY_ENTRY_EXPORT             0
#define PTR_ADD(_base,_offset)		((PVOID)((PBYTE)(_base)+(DWORD)(_offset)))
#define InitializeObjectAttributes( p, n, a, r, s ) { \
    (p)->Length = sizeof( OBJECT_ATTRIBUTES );          \
    (p)->RootDirectory = r;                             \
    (p)->Attributes = a;                                \
    (p)->ObjectName = n;                                \
    (p)->SecurityDescriptor = s;                        \
    (p)->SecurityQualityOfService = NULL;               \
    }




// STRUCTURES
struct _sDataStruct{
	DWORD		Status;
	UCHAR		c1;
	UCHAR		c2;
	UCHAR		c3;
	UCHAR		c4;
	UCHAR		b[512];
};extern struct _sDataStruct dStruct;



typedef struct _MODULE_INFO{
	DWORD		Reserved1;
	DWORD		Reserved2;
	PVOID		pBase;
	DWORD		dSize;
	DWORD		dFlags;
	WORD		wIndex;
	WORD		wRank;
	WORD		wLoadCount;
	WORD		wNameOffset;
	BYTE		abPath[256];
}MODULE_INFO, *PMODULE_INFO, **PPMODULE_INFO;



typedef struct _MODULE_LIST{
	DWORD		dModules;
	MODULE_INFO	aModules [];
}MODULE_LIST, *PMODULE_LIST, **PPMODULE_LIST;


typedef struct _IMAGE_FILE_HEADER{
    WORD  Machine;
    WORD  NumberOfSections;
    DWORD TimeDateStamp;
    DWORD PointerToSymbolTable;
    DWORD NumberOfSymbols;
    WORD  SizeOfOptionalHeader;
    WORD  Characteristics;
}IMAGE_FILE_HEADER, *PIMAGE_FILE_HEADER;



typedef struct _IMAGE_DATA_DIRECTORY
    {
    DWORD VirtualAddress;
    DWORD Size;
}IMAGE_DATA_DIRECTORY, *PIMAGE_DATA_DIRECTORY;



typedef struct _IMAGE_OPTIONAL_HEADER{
    WORD                 Magic;
    BYTE                 MajorLinkerVersion;
    BYTE                 MinorLinkerVersion;
    DWORD                SizeOfCode;
    DWORD                SizeOfInitializedData;
    DWORD                SizeOfUninitializedData;
    DWORD                AddressOfEntryPoint;
    DWORD                BaseOfCode;
    DWORD                BaseOfData;
    DWORD                ImageBase;
    DWORD                SectionAlignment;
    DWORD                FileAlignment;
    WORD                 MajorOperatingSystemVersion;
    WORD                 MinorOperatingSystemVersion;
    WORD                 MajorImageVersion;
    WORD                 MinorImageVersion;
    WORD                 MajorSubsystemVersion;
    WORD                 MinorSubsystemVersion;
    DWORD                Win32VersionValue;
    DWORD                SizeOfImage;
    DWORD                SizeOfHeaders;
    DWORD                CheckSum;
    WORD                 Subsystem;
    WORD                 DllCharacteristics;
    DWORD                SizeOfStackReserve;
    DWORD                SizeOfStackCommit;
    DWORD                SizeOfHeapReserve;
    DWORD                SizeOfHeapCommit;
    DWORD                LoaderFlags;
    DWORD                NumberOfRvaAndSizes;
    IMAGE_DATA_DIRECTORY DataDirectory[16];
}IMAGE_OPTIONAL_HEADER, *PIMAGE_OPTIONAL_HEADER;



typedef struct _IMAGE_NT_HEADERS{
    DWORD                 Signature;
    IMAGE_FILE_HEADER     FileHeader;
    IMAGE_OPTIONAL_HEADER OptionalHeader;
}IMAGE_NT_HEADERS, *PIMAGE_NT_HEADERS;


typedef struct _IMAGE_EXPORT_DIRECTORY{
    DWORD Characteristics;
    DWORD TimeDateStamp;
    WORD  MajorVersion;
    WORD  MinorVersion;
    DWORD Name;
    DWORD Base;
    DWORD NumberOfFunctions;
    DWORD NumberOfNames;
    DWORD AddressOfFunctions;
    DWORD AddressOfNames;
    DWORD AddressOfNameOrdinals;
}IMAGE_EXPORT_DIRECTORY, *PIMAGE_EXPORT_DIRECTORY;




// PROTOTYPES
PIMAGE_NT_HEADERS NTAPI RtlImageNtHeader (PVOID Base);



NTSTATUS NTAPI ZwQuerySystemInformation (DWORD  SystemInformationClass,
        PVOID SystemInformation, DWORD SystemInformationLength, PDWORD ReturnLength);

